#pragma once


// ArmarX
#include <ArmarXCore/core/Component.h>

// RobotAPI
#include <RobotAPI/interface/armem/server/MemoryInterface.h>
#include <RobotAPI/libraries/armem/client/ReaderComponentPlugin.h>
#include <RobotAPI/libraries/armem/client/WriterComponentPlugin.h>



namespace armarx::armem::client
{

    /**
     * @brief Utility for connecting a Client via Ice to ArMem.
     */
    class ComponentPluginUser :
        virtual public ReaderComponentPluginUser,
        virtual public WriterComponentPluginUser
    {

    public:

        ComponentPluginUser();
        ~ComponentPluginUser() override;


        /**
         * @brief Resolve the given memory name, add it as dependency and update the readers and writers.
         * @param The memory's name.
         * @return The result of `waitForMemory()`.
         * @see `armem::mns::plugins::ClientPluginUserBase::useMemory()`
         */
        virtual armem::data::WaitForMemoryResult useMemory(const std::string& memoryName) override;
        using mns::plugins::ClientPluginUserBase::useMemory;

    protected:

        void setMemory(server::MemoryInterfacePrx memory);

    };

}
