#include <RobotAPI/libraries/armem/client/ReaderComponentPlugin.h>


// ArmarX
#include <ArmarXCore/core/exceptions/local/ExpressionException.h>

// RobotAPI
#include <RobotAPI/libraries/armem/core/error.h>


namespace armarx::armem::client::plugins
{
    ReaderComponentPlugin::~ReaderComponentPlugin()
    {
        // pass
    }

    void
    ReaderComponentPlugin::postCreatePropertyDefinitions(PropertyDefinitionsPtr& properties)
    {
        ClientPlugin::postCreatePropertyDefinitions(properties);
        properties->topic<MemoryListenerInterface>("MemoryUpdates");
    }
}



namespace armarx::armem::client
{
    ReaderComponentPluginUser::ReaderComponentPluginUser()
    {
        addPlugin(plugin);
    }


    ReaderComponentPluginUser::~ReaderComponentPluginUser()
    {
        // pass
    }


    void
    ReaderComponentPluginUser::memoryUpdated(
        const std::vector<data::MemoryID>& updatedSnapshotIDsIce, const Ice::Current&)
    {
        std::vector<MemoryID> updatedSnapshotIDs;
        fromIce(updatedSnapshotIDsIce, updatedSnapshotIDs);
        memoryReader.updated(updatedSnapshotIDs);
    }


    void
    ReaderComponentPluginUser::setReadingMemory(server::ReadingMemoryInterfacePrx memory)
    {
        memoryReader.setReadingMemory(memory);
    }

    armem::data::WaitForMemoryResult ReaderComponentPluginUser::useMemory(const std::string& memoryName)
    {
        armem::data::WaitForMemoryResult result = mns::plugins::ClientPluginUserBase::useMemory(memoryName);
        if (result.proxy)
        {
            setReadingMemory(result.proxy);
        }
        return result;
    }
}
