#pragma once


// ArmarX
#include <ArmarXCore/core/Component.h>

// RobotAPI
#include <RobotAPI/libraries/aron/core/navigator/data/AllNavigators.h>
#include <RobotAPI/interface/armem/server/WritingMemoryInterface.h>
#include <RobotAPI/interface/armem/mns/MemoryNameSystemInterface.h>

#include <RobotAPI/libraries/armem/client/Writer.h>
#include <RobotAPI/libraries/armem/mns/ClientPlugin.h>


namespace armarx::armem::client::plugins
{

    class WriterComponentPlugin : public mns::plugins::ClientPlugin
    {

    public:

        using mns::plugins::ClientPlugin::ClientPlugin;
        ~WriterComponentPlugin() override;

    };
}


namespace armarx::armem::client
{
    class WriterComponentPluginUser :
        virtual public ManagedIceObject,
        virtual public mns::plugins::ClientPluginUserBase
    {

    public:

        WriterComponentPluginUser();
        ~WriterComponentPluginUser() override;

        virtual armem::data::WaitForMemoryResult useMemory(const std::string& memoryName) override;
        using mns::plugins::ClientPluginUserBase::useMemory;

    protected:

        void setWritingMemory(server::WritingMemoryInterfacePrx memory);

        Writer memoryWriter;

    private:

        plugins::WriterComponentPlugin* plugin = nullptr;

    };

}
