#pragma once

#include "../base/MemoryBase.h"

#include "CoreSegment.h"

#include "../workingmemory/Memory.h"
#include "mongodb/MongoDBConnectionManager.h"

namespace armarx::armem::ltm
{
    /**
     * @brief Data of a memory consisting of multiple core segments.
     */
    class Memory :
        public base::MemoryBase<CoreSegment, Memory>
    {
        using Base = base::MemoryBase<CoreSegment, Memory>;

    public:

        using Base::MemoryBase;
        using Base::operator=;


        // Conversion
        wm::Memory convert() const;

        // MongoDB connection
        void reload(const MongoDBConnectionManager::MongoDBSettings&);
        void append(const wm::Memory&);


    public:
        MongoDBConnectionManager::MongoDBSettings dbsettings;
    };
}
