#pragma once

#include "../base/MemoryBase.h"

#include "CoreSegment.h"
#include "detail/CopyWithoutData.h"


namespace armarx::armem::wm
{

    /**
     * @brief Data of a memory consisting of multiple core segments.
     */
    class Memory :
        public base::MemoryBase<CoreSegment, Memory>,
        public detail::CopyWithoutData<Memory>
    {
        using Base = base::MemoryBase<CoreSegment, Memory>;

    public:

        using Base::MemoryBase;

        Memory(const Memory& other) = default;
        Memory(Memory&& other) = default;
        Memory& operator=(const Memory& other) = default;
        Memory& operator=(Memory&& other) = default;


    protected:

        virtual void _copySelfWithoutData(Memory& other) const override;

    };
}
