#pragma once

#include <string>

#include <RobotAPI/libraries/aron/core/navigator/data/Navigator.h>
#include <RobotAPI/libraries/aron/core/navigator/data/container/Dict.h>
#include <RobotAPI/libraries/aron/core/navigator/data/container/List.h>

#include <RobotAPI/libraries/aron/core/navigator/type/Navigator.h>
#include <RobotAPI/libraries/aron/core/navigator/type/container/Dict.h>
#include <RobotAPI/libraries/aron/core/navigator/type/container/List.h>
#include <RobotAPI/libraries/aron/core/navigator/type/container/Object.h>
#include <RobotAPI/libraries/aron/core/navigator/type/container/Pair.h>
#include <RobotAPI/libraries/aron/core/navigator/type/container/Tuple.h>

#include "DataTreeBuilderBase.h"


class QStringList;


namespace armarx::armem::gui::instance
{

    class TypedDataTreeBuilder : public DataTreeBuilderBase
    {
    public:

        TypedDataTreeBuilder();


        void updateTree(QTreeWidgetItem* parent,
                        aron::typenavigator::DictNavigator& type,
                        aron::datanavigator::DictNavigator& data);
        void updateTree(QTreeWidgetItem* parent,
                        aron::typenavigator::ObjectNavigator& type,
                        aron::datanavigator::DictNavigator& data);

        void updateTree(QTreeWidgetItem* parent,
                        aron::typenavigator::ListNavigator& type,
                        aron::datanavigator::ListNavigator& data);
        void updateTree(QTreeWidgetItem* parent,
                        aron::typenavigator::PairNavigator& type,
                        aron::datanavigator::ListNavigator& data);
        void updateTree(QTreeWidgetItem* parent,
                        aron::typenavigator::TupleNavigator& type,
                        aron::datanavigator::ListNavigator& data);


    protected:

        void update(QTreeWidgetItem* item,
                    const std::string& key,
                    aron::typenavigator::Navigator& type,
                    aron::datanavigator::Navigator& data);

        template <class DataT, class TypeT>
        void _updateTree(QTreeWidgetItem* item, TypeT& type, aron::datanavigator::Navigator& data);

    };


}
